module Synthesizer.Generic.SampledValue where

import Foreign.Storable (Storable)
import StorableInstance ()

import qualified Number.Complex as Complex
import qualified Number.Ratio   as Ratio
import qualified Algebra.PrincipalIdealDomain as PID


class Storable a => C a -- where

instance C Bool -- where
instance C Int -- where
instance C Float -- where
instance C Double -- where
instance (C a, C b) => C (a,b) -- where
instance (C a, C b, C c) => C (a,b,c) -- where
instance (C a) => C (Complex.T a) -- where
instance (C a, PID.C a) => C (Ratio.T a) -- where
