module Main where

import qualified Test.Sound.Synthesizer.Plain.Analysis       as Analysis
import qualified Test.Sound.Synthesizer.Plain.Control        as Control
import qualified Test.Sound.Synthesizer.Plain.Filter         as Filter
import qualified Test.Sound.Synthesizer.Plain.Interpolation  as Interpolation
import qualified Test.Sound.Synthesizer.Plain.Oscillator     as Oscillator
import qualified Test.Sound.Synthesizer.Plain.ToneModulation as ToneModulation
import qualified Test.Sound.Synthesizer.Plain.Wave           as Wave

prefix :: String -> [(String, IO ())] -> [(String, IO ())]
prefix msg =
   map (\(str,test) -> (msg ++ "." ++ str, test))

main :: IO ()
main =
   mapM_ (\(msg,io) -> putStr (msg++": ") >> io) $
   concat $
      prefix "Plain.Analysis"       Analysis.tests :
      prefix "Plain.Control"        Control.tests :
      prefix "Plain.Filter"         Filter.tests :
      prefix "Plain.Interpolation"  Interpolation.tests :
      prefix "Plain.Oscillator"     Oscillator.tests :
      prefix "Plain.ToneModulation" ToneModulation.tests :
      prefix "Plain.Wave"           Wave.tests :
      []
